scala.util.parsing.ast.Binders

# BoundElement

#### case class BoundElement[boundElement <: NameElement](el: boundElement, scope: Scope[boundElement]) extends NameElement with Proxy with BindingSensitive with Product with Serializable

A `BoundElement` is bound in a certain scope `scope`, which keeps track of the actual element that `el` stands for.

A `BoundElement` is represented textually by its bound element, followed by its scope's `id`. For example: `x@1` represents the variable `x` that is bound in the scope with `id` `1`.

Source
  Binders.scala
Note

  `scope.binds(el)` holds before and after.

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, BindingSensitive, Proxy, Binders.NameElement, Binders.Element, Positional, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. BoundElement
2. Serializable
3. Serializable
4. Product
5. Equals
6. BindingSensitive
7. Proxy
8. NameElement
9. Element
10. Positional
11. AnyRef
12. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new BoundElement(el: boundElement, scope: Scope[boundElement])

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from BoundElement[boundElement] to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (BoundElement[boundElement], B)

   Implicit information
     This member is added by an implicit conversion from BoundElement[boundElement] to ArrowAssoc[BoundElement[boundElement]] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline ()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

8. #### def alpha_==[t <: Binders.NameElement](other: BoundElement[t]): Boolean

9. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

10. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )
    Note

      not specified by SLS as a member of AnyRef

11. #### val el: boundElement

12. #### def ensuring(cond: (BoundElement[boundElement]) ⇒ Boolean, msg: ⇒ Any): BoundElement[boundElement]

    Implicit information
      This member is added by an implicit conversion from BoundElement[boundElement] to Ensuring[BoundElement[boundElement]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: (BoundElement[boundElement]) ⇒ Boolean): BoundElement[boundElement]

    Implicit information
      This member is added by an implicit conversion from BoundElement[boundElement] to Ensuring[BoundElement[boundElement]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean, msg: ⇒ Any): BoundElement[boundElement]

    Implicit information
      This member is added by an implicit conversion from BoundElement[boundElement] to Ensuring[BoundElement[boundElement]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean): BoundElement[boundElement]

    Implicit information
      This member is added by an implicit conversion from BoundElement[boundElement] to Ensuring[BoundElement[boundElement]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

17. #### def equals(that: Any): Boolean

    Compares the receiver object (`this`) with the argument object (`that`) for equivalence.

    Compares the receiver object (`this`) with the argument object (`that`) for equivalence.

    Any implementation of this method should be an equivalence relation:

    - It is reflexive: for any instance `x` of type `Any`, `x.equals(x)` should return `true`.
    - It is symmetric: for any instances `x` and `y` of type `Any`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
    - It is transitive: for any instances `x`, `y`, and `z` of type `AnyRef` if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.

    If you override this method, you should verify that your implementation remains an equivalence relation. Additionally, when overriding this method it is usually necessary to override `hashCode` to ensure that objects which are "equal" (`o1.equals(o2)` returns `true`) hash to the same scala.Int. (`o1.hashCode.equals(o2.hashCode)`).

    that

      the object to compare against this object for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Proxy → Any

18. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

19. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from BoundElement[boundElement] to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline ()

20. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

21. #### def hashCode(): Int

    Calculate a hash code value for the object.

    Calculate a hash code value for the object.

    The default hashing algorithm is platform dependent.

    Note that it is allowed for two objects to have identical hash codes (`o1.hashCode.equals(o2.hashCode)`) yet not be equal (`o1.equals(o2)` returns `false`). A degenerate implementation could always return `0`. However, it is required that if two objects are equal (`o1.equals(o2)` returns `true`) that they have identical hash codes (`o1.hashCode.equals(o2.hashCode)`). Therefore, when overriding this method, be sure to verify that the behavior is consistent with the `equals` method.

    returns

      the hash code value for this object.

    Definition Classes
      Proxy → Any

22. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

23. #### def name: String

    Definition Classes
      BoundElement → NameElement

24. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

25. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

26. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

27. #### var pos: Position

    The source position of this object, initially set to undefined.

    The source position of this object, initially set to undefined.

    Definition Classes
      Positional

28. #### val scope: Scope[boundElement]

29. #### def self: Binders.Element

    Returns the element this `BoundElement` stands for.

    Returns the element this `BoundElement` stands for. The `Proxy` trait ensures `equals`, `hashCode` and `toString` are forwarded to the result of this method.

    Definition Classes
      BoundElement → Proxy

30. #### def setPos(newpos: Position): BoundElement.this.type

    If current source position is undefined, update it with given position `newpos`

    If current source position is undefined, update it with given position `newpos`

    returns

      the object itself

    Definition Classes
      Positional

31. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

32. #### def toString(): String

    Returns a string representation of the object.

    Returns a string representation of the object.

    The default representation is platform dependent.

    returns

      a string representation of the object.

    Definition Classes
      BoundElement → Proxy → AnyRef → Any

33. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

34. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

35. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

36. #### def →[B](y: B): (BoundElement[boundElement], B)

    Implicit information
      This member is added by an implicit conversion from BoundElement[boundElement] to ArrowAssoc[BoundElement[boundElement]] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from BoundElement[boundElement] to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (boundElement: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from BoundElement[boundElement] to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (boundElement: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: BoundElement[boundElement]

   Implicit information
     This member is added by an implicit conversion from BoundElement[boundElement] to ArrowAssoc[BoundElement[boundElement]] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (boundElement: ArrowAssoc[BoundElement[boundElement]]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: BoundElement[boundElement]

   Implicit information
     This member is added by an implicit conversion from BoundElement[boundElement] to Ensuring[BoundElement[boundElement]] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (boundElement: Ensuring[BoundElement[boundElement]]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from BindingSensitive

### Inherited from Proxy

### Inherited from Binders.NameElement

### Inherited from Binders.Element

### Inherited from Positional

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from BoundElement[boundElement] to StringAdd

### Inherited by implicit conversion any2stringfmt from BoundElement[boundElement] to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from BoundElement[boundElement] to ArrowAssoc[BoundElement[boundElement]]

### Inherited by implicit conversion any2Ensuring from BoundElement[boundElement] to Ensuring[BoundElement[boundElement]]

### Ungrouped